//+------------------------------------------------------------------+
//|                                                  Correlation.mq4 |
//|                                Copyright  2008, Victor Nicolaev |
//|                                             http://vinin.ucoz.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Victor Nicolaev"
#property link      "http://vinin.ucoz.ru"

#property indicator_separate_window
#property indicator_buffers   1
#property indicator_color1 Green
#property indicator_maximum   1
#property indicator_minimum  -1
#property indicator_level1    0.7
#property indicator_level2    0.0
#property indicator_level3   -0.7


//---- input parameters

extern string    _Symbol="GBPUSD";
extern int        CorrBar= 30;
extern int        Limit=1440;

//---- buffers
double Buffer0[];


bool  bSymbol;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {

   SetIndexStyle(0,DRAW_LINE);

   SetIndexBuffer(0,Buffer0);
   
   IndicatorShortName("Correlation("+Symbol()+"/"+_Symbol+")");
   
   SetIndexDrawBegin(0,CorrBar);
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()  {
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int i,limit,counted_bars=IndicatorCounted();
   
   if ( counted_bars < 0 ) return(-1);

   limit=Bars;
   if(counted_bars>0) limit=Bars-counted_bars;

   limit--;
   if (limit>Limit && Limit>0) limit=Limit;
   

   for( i=limit; i>=0; i--) {
      Buffer0[i]=correlation(i, CorrBar);
   }
   return(0);
}

double correlation(int pos, int CorrBar){
   double RetVal=0;
   double sx=0, sy=0, dx=0, dy=0,dxy=0,sdxy=0;
   int ix,iy,t;   
   sx=iMA(Symbol(),0,CorrBar,0,MODE_SMA,PRICE_CLOSE,pos);
   sy=iMA(_Symbol, 0,CorrBar,0,MODE_SMA,PRICE_CLOSE,pos);

   for (int i=0; i<CorrBar; i++)  {
      dx+=MathPow(Close[pos+i]-sx,2);
      t=iBarShift(_Symbol,0,Time[pos+i]);
      dy+=MathPow(iClose(_Symbol,0,t)-sy,2);
      dxy+=(Close[i+pos]-sx)*(iClose(_Symbol,0,t)-sy);
   }
   
   sdxy=MathSqrt(dx*dy);

   if (sdxy>0) RetVal=dxy/sdxy;
   return(RetVal);
}


